Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 795231 (CVE-2019-17567, CVE-2020-13950, CVE-2020-35452, CVE-2021-26690, CVE-2021-26691, CVE-2021-30641, CVE-2021-31618) - <www-servers/apache-2.4.48: multiple vulnerabilities (CVE-2019-17567, CVE-2020-{13950,35452}, CVE-2021-{26690,26691,30641,31618})
Summary: <www-servers/apache-2.4.48: multiple vulnerabilities (CVE-2019-17567, CVE-202...
Status: RESOLVED FIXED
Alias: CVE-2019-17567, CVE-2020-13950, CVE-2020-35452, CVE-2021-26690, CVE-2021-26691, CVE-2021-30641, CVE-2021-31618
Product: Gentoo Security
Classification: Unclassified
Component: Vulnerabilities (show other bugs)
Hardware: All Linux
: Normal minor (vote)
Assignee: Gentoo Security
URL: https://httpd.apache.org/security/vul...
Whiteboard: B3 [glsa+ cve]
Keywords:
Depends on:
Blocks:
 
Reported: 2021-06-10 14:43 UTC by John Helmert III
Modified: 2021-07-18 15:30 UTC (History)
2 users (show)

See Also:
Package list:
app-admin/apache-tools-2.4.48-r1 www-servers/apache-2.4.48-r1
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description John Helmert III gentoo-dev Security 2021-06-10 14:43:10 UTC
CVE-2019-17567:

Apache HTTP Server versions 2.4.6 to 2.4.46 mod_proxy_wstunnel configured on an URL that is not necessarily Upgraded by the origin server was tunneling the whole connection regardless, thus allowing for subsequent requests on the same connection to pass through with no HTTP validation, authentication or authorization possibly configured.

CVE-2020-13950:

Apache HTTP Server versions 2.4.41 to 2.4.46 mod_proxy_http can be made to crash (NULL pointer dereference) with specially crafted requests using both Content-Length and Transfer-Encoding headers, leading to a Denial of Service

CVE-2020-35452:

Apache HTTP Server versions 2.4.0 to 2.4.46 A specially crafted Digest nonce can cause a stack overflow in mod_auth_digest. There is no report of this overflow being exploitable, nor the Apache HTTP Server team could create one, though some particular compiler and/or compilation option might make it possible, with limited consequences anyway due to the size (a single byte) and the value (zero byte) of the overflow

CVE-2021-26690:

Apache HTTP Server versions 2.4.0 to 2.4.46 A specially crafted Cookie header handled by mod_session can cause a NULL pointer dereference and crash, leading to a possible Denial Of Service

CVE-2021-26691:

Apache HTTP Server versions 2.4.0 to 2.4.46 A specially crafted SessionHeader sent by an origin server could cause a heap overflow

CVE-2021-30641:

Apache HTTP Server versions 2.4.39 to 2.4.46 Unexpected matching behavior with 'MergeSlashes OFF'

CVE-2021-31618:

Apache HTTP Server protocol handler for the HTTP/2 protocol checks received request headers against the size limitations as configured for the server and used for the HTTP/1 protocol as well. On violation of these restrictions and HTTP response is sent to the client with a status code indicating why the request was rejected.

This rejection response was not fully initialised in the HTTP/2 protocol handler if the offending header was the very first one received or appeared in a a footer. This led to a NULL pointer dereference on initialised memory, crashing reliably the child process. Since such a triggering HTTP/2 request is easy to craft and submit, this can be exploited to DoS the server.


The notice on the website and the mail announcement for CVE-2021-31618 say different versions, the website saying <=2.4.48 is affected and the mail saying <2.4.47 is affected. Unsure which are actually affected.
Comment 1 John Helmert III gentoo-dev Security 2021-06-11 01:06:04 UTC
2.4.47 is the one with the fixes:

https://www.openwall.com/lists/oss-security/2021/06/10/16

Please stabilize >=2.4.47.
Comment 2 NATTkA bot gentoo-dev 2021-06-11 01:08:23 UTC Comment hidden (obsolete)
Comment 3 NATTkA bot gentoo-dev 2021-06-11 09:16:22 UTC Comment hidden (obsolete)
Comment 4 Tomáš Mózes 2021-06-11 11:19:20 UTC
https://downloads.apache.org/httpd/CHANGES_2.4.48

Changes with Apache 2.4.48
  *) SECURITY: CVE-2021-31618 (cve.mitre.org)
     mod_http2: Fix a potential NULL pointer dereference [Ivan Zhakov]
Comment 5 Sam James archtester gentoo-dev Security 2021-06-12 01:21:07 UTC
ppc done
Comment 6 Sam James archtester gentoo-dev Security 2021-06-12 04:18:59 UTC
amd64 done
Comment 7 Sam James archtester gentoo-dev Security 2021-06-12 04:19:01 UTC
x86 done
Comment 8 Rolf Eike Beer archtester 2021-06-12 10:14:59 UTC
sparc done
Comment 9 Agostino Sarubbo gentoo-dev 2021-06-13 06:29:31 UTC
ppc64 stable
Comment 10 Sam James archtester gentoo-dev Security 2021-06-13 22:36:25 UTC
arm64 done
Comment 11 NATTkA bot gentoo-dev 2021-06-22 20:56:23 UTC Comment hidden (obsolete)
Comment 12 NATTkA bot gentoo-dev 2021-06-22 21:00:26 UTC Comment hidden (obsolete)
Comment 13 NATTkA bot gentoo-dev 2021-06-23 00:04:25 UTC
All sanity-check issues have been resolved
Comment 14 Sam James archtester gentoo-dev Security 2021-07-15 00:00:25 UTC
arm done

all arches done
Comment 15 John Helmert III gentoo-dev Security 2021-07-15 05:30:34 UTC
Please cleanup
Comment 16 John Helmert III gentoo-dev Security 2021-07-17 03:52:44 UTC
GLSA request filed.
Comment 17 GLSAMaker/CVETool Bot gentoo-dev 2021-07-17 05:07:03 UTC
This issue was resolved and addressed in
 GLSA 202107-38 at https://security.gentoo.org/glsa/202107-38
by GLSA coordinator John Helmert III (ajak).
Comment 18 Larry the Git Cow gentoo-dev 2021-07-18 09:33:59 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=fed1cac86a11008071b5561d825d8cae53c0d158

commit fed1cac86a11008071b5561d825d8cae53c0d158
Author:     Hans de Graaff <graaff@gentoo.org>
AuthorDate: 2021-07-18 09:33:51 +0000
Commit:     Hans de Graaff <graaff@gentoo.org>
CommitDate: 2021-07-18 09:33:51 +0000

    www-servers/apache: cleanup vulnerable versions
    
    Bug: https://bugs.gentoo.org/795231
    Package-Manager: Portage-3.0.20, Repoman-3.0.2
    Signed-off-by: Hans de Graaff <graaff@gentoo.org>

 www-servers/apache/Manifest                |   3 -
 www-servers/apache/apache-2.4.46-r7.ebuild | 246 ----------------------------
 www-servers/apache/apache-2.4.46-r8.ebuild | 253 -----------------------------
 www-servers/apache/apache-2.4.47-r1.ebuild | 253 -----------------------------
 4 files changed, 755 deletions(-)
Comment 19 John Helmert III gentoo-dev Security 2021-07-18 15:30:56 UTC
Thanks graaff, not sure how I missed this